import { watch as F, nextTick as j, ref as c, computed as J, resolveComponent as r, openBlock as g, createBlock as U, unref as f, isRef as T, withCtx as o, createElementVNode as w, createVNode as d, createTextVNode as h, toDisplayString as y, createElementBlock as K, Fragment as $, withModifiers as A } from "vue";
import "./TreeDialog.vue2.js";
const M = { key: 1 }, z = { class: "dialog-footer" }, I = {
  __name: "TreeDialog",
  props: {
    modelValue: {
      type: Boolean,
      default: !1
    },
    title: {
      type: String,
      default: "选择树形"
    },
    width: {
      type: String,
      default: "50%"
    },
    class: {
      type: String,
      default: ""
    },
    submitButtonText: {
      type: String,
      default: "确 定"
    },
    cancelButtonText: {
      type: String,
      default: "取 消"
    },
    data: {
      type: Object,
      default: []
    },
    selectType: {
      type: String,
      default: "checkbox"
    },
    selectValue: {
      type: Object,
      default: []
    },
    selectKey: {
      type: String,
      required: !0
    },
    parentSelectKey: {
      type: String,
      required: !0
    },
    showFieldName: {
      type: String,
      required: !0
    }
  },
  emits: ["submit", "update:modelValue"],
  setup(N, { emit: C }) {
    const e = N;
    F(
      () => e.modelValue,
      (t) => {
        t && (a.value = t, j(() => {
          q();
        }));
      }
    );
    const a = c(!1), _ = C, B = () => {
      _("update:modelValue", !1);
    }, b = c([]), D = J(() => {
      let t = R(e.data);
      for (let l of t)
        b.value.push(l[e.selectKey]);
      return t;
    });
    function R(t) {
      let l = JSON.parse(JSON.stringify(t));
      return l.filter((n) => {
        let p = l.filter(
          (m) => n[e.selectKey] == m[e.parentSelectKey]
        );
        return p.length > 0 && (n.children = p), !n[e.parentSelectKey];
      });
    }
    const u = c();
    function O() {
      let t = [];
      e.selectType == "checkbox" ? t = u.value.getCheckedNodes() : t = k.value, _("submit", t), a.value = !1;
    }
    function q() {
      if (e.selectValue.length > 0)
        if (e.selectType == "checkbox")
          u.value.setCheckedKeys(e.selectValue);
        else {
          let t = u.value.getNode(e.selectValue);
          x(t.data);
        }
    }
    const i = c(!1), k = c({});
    function x(t) {
      k.value = t, i.value = t[e.selectKey];
    }
    return (t, l) => {
      const n = r("el-radio"), p = r("el-tree"), m = r("el-scrollbar"), V = r("el-button"), E = r("el-dialog");
      return g(), U(E, {
        modelValue: f(a),
        "onUpdate:modelValue": l[2] || (l[2] = (s) => T(a) ? a.value = s : null),
        title: e.title || "新增/修改模型",
        onClose: B,
        "destroy-on-close": "",
        draggable: "",
        "append-to-body": "",
        "close-on-click-modal": !1,
        "close-on-press-escape": !1,
        width: e.width,
        "custom-class": e.class + " tree-dialog"
      }, {
        footer: o(() => [
          w("span", z, [
            d(V, {
              onClick: l[1] || (l[1] = (s) => a.value = !1)
            }, {
              default: o(() => [
                h(y(e.cancelButtonText), 1)
              ]),
              _: 1
            }),
            d(V, {
              type: "primary",
              onClick: O
            }, {
              default: o(() => [
                h(y(e.submitButtonText), 1)
              ]),
              _: 1
            })
          ])
        ]),
        default: o(() => [
          d(m, null, {
            default: o(() => [
              d(p, {
                data: f(D),
                "node-key": e.selectKey,
                "highlight-current": "",
                "default-expanded-keys": f(b),
                "show-checkbox": e.selectType == "checkbox",
                props: {
                  children: "children",
                  label: e.showFieldName
                },
                ref_key: "treeRef",
                ref: u
              }, {
                default: o(({ node: s, data: S }) => [
                  e.selectType == "radio" ? (g(), K($, { key: 0 }, [
                    d(n, {
                      label: S[e.selectKey],
                      modelValue: f(i),
                      "onUpdate:modelValue": l[0] || (l[0] = (v) => T(i) ? i.value = v : null),
                      onClick: A((v) => x(S), ["stop"])
                    }, {
                      default: o(() => [
                        h(" ")
                      ]),
                      _: 2
                    }, 1032, ["label", "modelValue", "onClick"]),
                    w("span", null, y(s.label), 1)
                  ], 64)) : (g(), K("span", M, y(s.label), 1))
                ]),
                _: 1
              }, 8, ["data", "node-key", "default-expanded-keys", "show-checkbox", "props"])
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["modelValue", "title", "width", "custom-class"]);
    };
  }
};
export {
  I as default
};
