import { inject as y, ref as s, computed as N, watch as b, nextTick as P, resolveComponent as S, openBlock as x, createElementBlock as T, Fragment as q, unref as i, createBlock as B, mergeProps as F, isRef as J, toHandlers as U, createCommentVNode as H, createElementVNode as M, toDisplayString as R } from "vue";
import A from "../../../utils/formUtil.js";
import { getLibraryOptionData4Cascader as C } from "../../../utils/libraryUtil.js";
import { getPlaceholder as G } from "../../../utils/i18nUtil.js";
const K = { class: "layout layout-form-text" }, Z = {
  __name: "Cascader",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    query: String,
    event: Object,
    modelValue: Array,
    pramDicItem: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["update:modelValue"],
  setup(V, { emit: _ }) {
    const c = y("formData");
    y("isLayout");
    const v = y("changeFieldData"), d = s(), t = V, j = _, u = N({
      get: () => t.modelValue,
      set: (e) => {
        j("update:modelValue", e);
      }
    }), I = N(() => !!(t.option.disabled || t.option.readOnly));
    function w(e) {
      let l = d.value.getCheckedNodes(), a = [];
      l.forEach((n) => {
        let r;
        if (t.option.showAll) {
          let o = t.option.separator || "/";
          r = n.pathLabels.join(o);
        } else {
          let o = n.pathLabels;
          r = o[o.length - 1];
        }
        a.push(r);
      }), c.value[t.option.fieldDesc] = a.join("|"), v && v(t.option.fieldName, e);
    }
    const f = s([]);
    function z(e) {
      C(
        c.value,
        t.option,
        e,
        f
      );
    }
    const g = s(), m = s(""), D = s(!0);
    b(f, (e) => {
      g.value = O(e), t.query == "query" && P(() => {
        let l = d.value.getCheckedNodes(), a = [];
        l.forEach((n) => {
          let r;
          if (t.option.showAll) {
            let o = t.option.separator || "/";
            r = n.pathLabels.join(" " + o + " ");
          } else {
            let o = n.pathLabels;
            r = o[o.length - 1];
          }
          a.push(r);
        }), m.value = a.join(" | ");
      });
    }), b(m, (e) => {
      e && (D.value = !1);
    });
    const p = s();
    b(
      () => t.option,
      (e) => {
        if (e.optionType === "2" && t.pramDicItem) {
          p.value = {
            value: "optCode",
            label: "optName"
          };
          let l = A.clone(t.pramDicItem);
          l.forEach((a) => {
            a.id = a.dicPkId, a.pid = a.ppkId;
          }), f.value = l;
        } else
          e.optionType === "3" && (p.value = {
            value: "optCode",
            label: "optName",
            multiple: e.multiple == !0,
            lazy: !!e.lazyLoad,
            checkStrictly: !!e.checkArbitrarily,
            /* 级联数据懒加载 */
            lazyLoad(l, a) {
              let n = l.data.id || "", o = {
                [e.library.parentPrimaryId]: n
              };
              o.isLazy = !0, C(
                c.value,
                e,
                o,
                null,
                (k) => {
                  a(k);
                }
              );
            }
          }, p.value.lazy || z({ isLazy: !1 }));
      },
      {
        deep: !0,
        immediate: !0
      }
    );
    function O(e) {
      let l = JSON.parse(JSON.stringify(e)), a = l.filter((r) => {
        let o = l.filter((h) => r.id == h.pid);
        return r.leaf = !0, o.length > 0 && (r.children = o, r.leaf = !1), !l.find((h) => r.pid == h.id);
      }), n = t.option.maxLvl;
      return a = L(a, n), a;
    }
    function L(e, l = 10) {
      return e ? e.map((a) => {
        let n = l <= 1 ? [] : L(a.children, l - 1), r = !1;
        return n.length == 0 && (r = !0), {
          ...a,
          children: n,
          leaf: r
        };
      }) : [];
    }
    function E(e, l) {
      return e.pathLabels.join(",").indexOf(l) != -1;
    }
    return (e, l) => {
      const a = S("el-cascader");
      return x(), T(q, null, [
        i(D) ? (x(), B(a, F({
          key: 0,
          modelValue: i(u),
          "onUpdate:modelValue": l[0] || (l[0] = (n) => J(u) ? u.value = n : null),
          options: i(g),
          ref_key: "cascader",
          ref: d,
          clearable: "",
          filterable: !t.option.lazyLoad,
          "filter-method": E,
          props: i(p),
          placeholder: i(G)(t.option),
          disabled: i(I)
        }, U(t.event), {
          separator: i(A).isEmpty(t.option.separator) ? "/" : t.option.separator,
          "show-all-levels": t.option.showAll,
          onChange: w
        }), null, 16, ["modelValue", "options", "filterable", "props", "placeholder", "disabled", "separator", "show-all-levels"])) : H("", !0),
        M("div", K, R(i(m)), 1)
      ], 64);
    };
  }
};
export {
  Z as default
};
