import { inject as d, ref as g, computed as F, resolveComponent as v, openBlock as b, createBlock as V, mergeProps as S, unref as a, isRef as E, toHandlers as T } from "vue";
import o from "../../../utils/formUtil.js";
import { getPlaceholder as D, getEndPlaceholder as M } from "../../../utils/i18nUtil.js";
const B = {
  __name: "DateGroup",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String,
    isEdit: {
      type: Boolean,
      default: !1
    },
    isTableSearch: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue"],
  setup(r, { emit: m }) {
    d("formData");
    const n = d("changeFieldData"), e = r, p = g(e.option.dateType);
    e.isEdit && (e.option.fieldType == "dateGroup" || e.option.fieldType == "datetimeGroup") && (p.value = "date");
    const s = m, l = F({
      get: () => e.modelValue,
      set: (t) => {
        s("update:modelValue", t);
      }
    });
    function u(t) {
      n && n(e.option.fieldName, t);
    }
    function f() {
      let t = "YYYY-MM-DD";
      return o.isEmpty(e.option.dateFormat.format) || (t = e.option.dateFormat.format.toUpperCase(), t = t.replace("HH:MM:SS", "hh:mm:ss")), e.isTableSearch && (t = t.replace("hh:mm:ss", "")), t;
    }
    function c() {
      let t = null;
      return o.isEmpty(e.option.dateFormat.valueFormat) || (t = e.option.dateFormat.valueFormat.toUpperCase(), t = t.replace("HH:MM:SS", "hh:mm:ss")), e.isTableSearch && (t = t.replace("hh:mm:ss", "")), t;
    }
    return (t, i) => {
      const h = v("el-date-picker");
      return b(), V(h, S({
        ref: "dateRef",
        modelValue: a(l),
        "onUpdate:modelValue": i[0] || (i[0] = (y) => E(l) ? l.value = y : null),
        format: f(),
        "value-format": c(),
        type: a(p),
        "unlink-panels": "",
        "range-separator": e.option.separator,
        "start-placeholder": a(D)(e.option),
        "end-placeholder": a(M)(e.option),
        disabled: a(o).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
        readonly: a(o).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly
      }, T(r.event), { onChange: u }), null, 16, ["modelValue", "format", "value-format", "type", "range-separator", "start-placeholder", "end-placeholder", "disabled", "readonly"]);
    };
  }
};
export {
  B as default
};
