import { inject as c, computed as f, resolveComponent as h, openBlock as g, createBlock as w, mergeProps as y, unref as o, isRef as V, toHandlers as x, withCtx as _, createTextVNode as b, toDisplayString as v } from "vue";
import n from "../../../utils/formUtil.js";
import { getPlaceholder as O, getSuffix as j } from "../../../utils/i18nUtil.js";
const S = {
  __name: "Password",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(p, { emit: r }) {
    const a = c("changeFieldData"), e = p, d = r, l = f({
      get: () => e.modelValue,
      set: (t) => {
        d("update:modelValue", t);
      }
    });
    function s(t) {
      a && a(e.option.fieldName, t);
    }
    return (t, i) => {
      const m = h("el-input");
      return g(), w(m, y({
        ref: "input",
        type: "password",
        modelValue: o(l),
        "onUpdate:modelValue": i[0] || (i[0] = (u) => V(l) ? l.value = u : null),
        placeholder: o(O)(e.option)
      }, x(e.event), {
        maxlength: e.option.maxlength,
        "show-word-limit": o(n).isEmpty(e.option["show-word-limit"]) ? !1 : e.option["show-word-limit"],
        disabled: o(n).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
        readonly: o(n).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly,
        clearable: !0,
        autocomplete: "off",
        onInput: s
      }), {
        suffix: _(() => [
          b(v(o(j)(e.option)), 1)
        ]),
        _: 1
      }, 16, ["modelValue", "placeholder", "maxlength", "show-word-limit", "disabled", "readonly"]);
    };
  }
};
export {
  S as default
};
