import { inject as m, ref as d, computed as f, resolveComponent as I, openBlock as N, createElementBlock as O, Fragment as R, createVNode as c, mergeProps as D, unref as n, isRef as g, toHandlers as S, withCtx as z, createTextVNode as E, toDisplayString as j } from "vue";
import v from "../../../utils/formUtil.js";
import k from "../../i18n/I18nDialog.vue.js";
import C from "../../../store/index.js";
import { getPlaceholder as F, getSuffix as U } from "../../../utils/i18nUtil.js";
const H = {
  __name: "Textarea",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(V, { emit: x }) {
    const s = m("formData"), p = m("changeFieldData"), e = V, h = x, u = d(""), a = f({
      get: () => {
        let t = e.modelValue;
        if (e.option.isI18n)
          try {
            u.value = JSON.parse(
              s.value[e.option.fieldName + "_I18n"]
            );
          } catch {
            u.value = "", a.value = t;
          }
        else
          a.value = t;
        return t;
      },
      set: (t) => {
        h("update:modelValue", t);
      }
    });
    function w(t) {
      p && p(e.option.fieldName, t);
    }
    const y = f(() => {
      let t = {};
      return e.option.isAutoRows ? t.minRows = 3 : (t.minRows = e.option.minRows || 3, t.maxRows = e.option.maxRows || 6), t;
    }), i = d(!1);
    function b() {
      e.option.isI18n && (i.value = !0, readOnly.value = !0);
    }
    function _(t) {
      let o = {}, r = "";
      t.forEach((l) => {
        o[l.lang] = l.content, l.lang == C.getters.i18n && (r = l.content);
      }), a.value = r, s.value[e.option.fieldName + "_I18n"] = JSON.stringify(o), i.value = !1;
    }
    return (t, o) => {
      const r = I("el-input");
      return N(), O(R, null, [
        c(r, D({
          ref: "input",
          type: "textarea",
          modelValue: n(a),
          "onUpdate:modelValue": o[0] || (o[0] = (l) => g(a) ? a.value = l : null),
          placeholder: n(F)(e.option)
        }, S(e.event), {
          onClick: b,
          maxlength: e.option.maxlength,
          "show-word-limit": !!e.option.maxlength,
          disabled: n(v).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
          readonly: n(v).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly,
          clearable: !0,
          autocomplete: "off",
          autosize: n(y),
          resize: "none",
          onInput: w
        }), {
          suffix: z(() => [
            E(j(n(U)(e.option)), 1)
          ]),
          _: 1
        }, 16, ["modelValue", "placeholder", "maxlength", "show-word-limit", "disabled", "readonly", "autosize"]),
        c(k, {
          modelValue: n(i),
          "onUpdate:modelValue": o[1] || (o[1] = (l) => g(i) ? i.value = l : null),
          title: e.option.label,
          data: n(u),
          onSubmit: _
        }, null, 8, ["modelValue", "title", "data"])
      ], 64);
    };
  }
};
export {
  H as default
};
