import { computed as p, watch as d, ref as f, openBlock as y, createBlock as V, unref as u, isRef as b } from "vue";
import { post as g } from "../../../axios/index.js";
import S from "../../dialog/treeDialog/TreeDialog.vue.js";
const B = {
  __name: "SysBrDialog",
  props: {
    modelValue: String | Number,
    title: {
      type: String,
      default: "选择系统机构"
    },
    initSearchData: {
      type: Object,
      default: {}
    },
    selectType: {
      type: String,
      default: "checkbox"
    },
    selectValue: {
      type: Object,
      default: []
    },
    selectKey: {
      type: String,
      default: "brNo"
    }
  },
  emits: ["submit", "update:modelValue"],
  setup(i, { emit: r }) {
    const t = i, s = r, o = p({
      get: () => t.modelValue,
      set: (e) => {
        s("update:modelValue", e);
      }
    });
    d(
      () => t.modelValue,
      (e) => {
        e && n();
      }
    );
    const c = f([]);
    function n() {
      let e = t.initSearchData;
      e.pageNo = 1, e.pageSize = 0, g(
        "/branch/sysBranch/findByPage",
        e,
        (l) => {
          if (l.code == 0) {
            let a = l.list;
            c.value = a.records || a;
          }
        }
      );
    }
    function m(e) {
      s("submit", e), t.modelValue = !1;
    }
    return (e, l) => (y(), V(u(S), {
      modelValue: u(o),
      "onUpdate:modelValue": l[0] || (l[0] = (a) => b(o) ? o.value = a : null),
      title: t.title,
      selectType: t.selectType,
      selectValue: t.selectValue,
      selectKey: t.selectKey || "brNo",
      parentSelectKey: "upOne",
      showFieldName: "brName",
      data: u(c),
      onSubmit: m
    }, null, 8, ["modelValue", "title", "selectType", "selectValue", "selectKey", "data"]));
  }
};
export {
  B as default
};
