import { inject as _, ref as F, watch as O, resolveComponent as m, openBlock as u, createElementBlock as y, Fragment as b, createBlock as h, withCtx as t, createVNode as l, createTextVNode as f, createCommentVNode as g, createElementVNode as E, renderList as H, toDisplayString as M, unref as U } from "vue";
import "../../../store/index.js";
import q from "../../../utils/formUtil.js";
import { getLabelContent as x } from "../../../utils/i18nUtil.js";
import { export_json_to_excel as A } from "../../../utils/Export2Excel.js";
const J = { style: { "text-align": "left" } }, G = {
  __name: "QueryModelBtns",
  props: {
    option: {
      type: Object,
      required: !0
    },
    pramDicItem: {
      type: Object,
      default() {
        return [];
      }
    }
  },
  setup(k) {
    const n = k, D = _("initTableData"), T = _("tableFormatter"), S = _("tableId"), V = _("tableName");
    function C(o) {
      I(o);
    }
    const w = F({});
    function I(o) {
      const s = sessionStorage.getItem(S), i = JSON.parse(s);
      o == "all" && (i.pageNo = 1, i.pageSize = 0), D(n.option, i, w);
    }
    O(w, (o) => {
      let s = [];
      for (let e in n.option.columns)
        n.option.columns[e].fieldName != "" && n.option.columns[e].isShow && s.push(x(n.option.columns[e]));
      const i = v(n.option.columns, o.tableData);
      let r = V.value + "_" + q.dateFormat(/* @__PURE__ */ new Date(), "yyyy-MM-dd HH:mm:ss");
      A(s, i, r);
    });
    function v(o, s) {
      return o = o.filter((r) => !!(r.fieldName != "" && r.isShow)), s.map((r) => o.map((e) => {
        if (e.fieldName != "" && e.isShow) {
          let a = r[e.fieldName];
          if (!a || e.dataType === "money(yuan)" || e.dataType === "money(qian)" || e.dataType === "money(wan)" || e.dataType === "percentile" || e.dataType === "thousand" || e.dataType === "tenThousand")
            return a;
          if (n.pramDicItem[e.fieldName] && n.pramDicItem[e.fieldName].length > 0) {
            let p = "";
            for (let c of n.pramDicItem[e.fieldName])
              a.split("|").indexOf(c.optCode) > -1 && (p += c.optName + ",");
            return p ? p.substring(0, p.length - 1) : a;
          } else
            return T(a, e);
        } else
          return null;
      }));
    }
    return (o, s) => {
      const i = m("download"), r = m("el-icon"), e = m("el-button"), a = m("el-dropdown-item"), p = m("el-dropdown-menu"), c = m("el-dropdown"), N = m("setting"), j = m("el-checkbox");
      return u(), y(b, null, [
        n.option.isExport ? (u(), h(c, {
          key: 0,
          style: { "margin-left": "12px" },
          "hide-on-click": !1,
          trigger: "click",
          onCommand: C
        }, {
          dropdown: t(() => [
            l(p, null, {
              default: t(() => [
                l(a, { command: "all" }, {
                  default: t(() => [
                    f("导出全部")
                  ]),
                  _: 1
                }),
                l(a, { command: "current" }, {
                  default: t(() => [
                    f("导出当前页")
                  ]),
                  _: 1
                })
              ]),
              _: 1
            })
          ]),
          default: t(() => [
            l(e, { type: "primary" }, {
              default: t(() => [
                l(r, null, {
                  default: t(() => [
                    l(i)
                  ]),
                  _: 1
                }),
                f("导出")
              ]),
              _: 1
            })
          ]),
          _: 1
        })) : g("", !0),
        n.option.isDColumn ? (u(), h(c, {
          key: 1,
          style: { "margin-left": "12px" },
          "hide-on-click": !1,
          trigger: "click"
        }, {
          dropdown: t(() => [
            E("div", J, [
              (u(!0), y(b, null, H(n.option.columns, (d) => (u(), y(b, {
                key: d.fieldName
              }, [
                d.fieldName ? (u(), h(a, {
                  key: 0,
                  disabled: d.isDisabled
                }, {
                  default: t(() => [
                    l(j, {
                      checked: d.isShow,
                      modelValue: d.isShow,
                      "onUpdate:modelValue": (B) => d.isShow = B,
                      disabled: d.isDisabled
                    }, {
                      default: t(() => [
                        f(M(U(x)(d)), 1)
                      ]),
                      _: 2
                    }, 1032, ["checked", "modelValue", "onUpdate:modelValue", "disabled"])
                  ]),
                  _: 2
                }, 1032, ["disabled"])) : g("", !0)
              ], 64))), 128))
            ])
          ]),
          default: t(() => [
            l(e, { type: "primary" }, {
              default: t(() => [
                l(r, null, {
                  default: t(() => [
                    l(N)
                  ]),
                  _: 1
                }),
                f("设置")
              ]),
              _: 1
            })
          ]),
          _: 1
        })) : g("", !0)
      ], 64);
    };
  }
};
export {
  G as default
};
