import { watch as O, nextTick as D, ref as s, resolveComponent as c, openBlock as C, createBlock as R, unref as b, isRef as I, withCtx as i, createElementVNode as U, createVNode as r, createTextVNode as y, toDisplayString as g } from "vue";
import d from "../../../store/index.js";
import "./TableDialog.vue2.js";
const j = { class: "dialog-footer" }, E = {
  __name: "TableDialog",
  props: {
    modelValue: {
      type: Boolean,
      default: !1
    },
    tableId: {
      type: String,
      default: ""
    },
    initOption: {
      type: Object,
      default: {
        width: "",
        value: ""
      }
    },
    initSearchData: {
      type: Object,
      default: {}
    },
    title: {
      type: String,
      default: "选择列表"
    },
    entitle: {
      type: String,
      default: "title"
    },
    width: {
      type: String,
      default: "50%"
    },
    class: {
      type: String,
      default: ""
    },
    submitButtonText: {
      type: String,
      default: "确 定"
    },
    cancelButtonText: {
      type: String,
      default: "取 消"
    },
    ensubmitButtonText: {
      type: String,
      default: "ok"
    },
    encancelButtonText: {
      type: String,
      default: "cancel"
    },
    selectType: {
      type: String,
      default: "checkbox"
    },
    selectValue: {
      type: Object,
      default: []
    },
    selectKey: {
      type: String,
      default: ""
    }
  },
  emits: ["submit", "update:modelValue"],
  setup(S, { emit: _ }) {
    const t = S;
    O(
      () => t.modelValue,
      (e) => {
        e && (a.value = e, v(), D(() => {
          x();
        }));
      }
    );
    const a = s(!1), p = _, h = () => {
      p("update:modelValue", !1);
    }, u = s();
    function k() {
      let e = [];
      e = u.value.getSelectionRows(), p("submit", e), a.value = !1;
    }
    const n = s({});
    function v() {
      let e = t.initOption;
      e.isInDialog = !0, e.isAutoHeight = !0;
      let l = t.selectValue;
      t.selectValue && !Array.isArray(t.selectValue) && (l = t.selectValue.split(","));
      let o = e.pkey || t.selectKey;
      e.pkey = o, t.selectType == "checkbox" ? (e.isSelect = !0, e.selectKey = o) : e.isRadio = !0, e.value = l, n.value = e;
    }
    function x() {
      n.value.value && u.value.setSelectionRows(n.value.value);
    }
    function T() {
      let e = "";
      switch (d.getters.i18n) {
        case "en_US":
          e = t.entitle;
          break;
        default:
          e = t.title || "标题";
          break;
      }
      return e;
    }
    function V() {
      let e = "";
      switch (d.getters.i18n) {
        case "en_US":
          e = t.encancelButtonText;
          break;
        default:
          e = t.cancelButtonText;
          break;
      }
      return e;
    }
    function w() {
      let e = "";
      switch (d.getters.i18n) {
        case "en_US":
          e = t.ensubmitButtonText;
          break;
        default:
          e = t.submitButtonText;
          break;
      }
      return e;
    }
    return (e, l) => {
      const o = c("h-table"), f = c("el-button"), B = c("el-dialog");
      return C(), R(B, {
        modelValue: b(a),
        "onUpdate:modelValue": l[1] || (l[1] = (m) => I(a) ? a.value = m : null),
        title: T(),
        onClose: h,
        "destroy-on-close": "",
        draggable: "",
        "append-to-body": "",
        "close-on-click-modal": !1,
        "close-on-press-escape": !1,
        width: t.initOption.width || t.width,
        "custom-class": t.class + " custom-dialog"
      }, {
        footer: i(() => [
          U("span", j, [
            r(f, {
              onClick: l[0] || (l[0] = (m) => a.value = !1)
            }, {
              default: i(() => [
                y(g(V()), 1)
              ]),
              _: 1
            }),
            r(f, {
              type: "primary",
              onClick: k
            }, {
              default: i(() => [
                y(g(w()), 1)
              ]),
              _: 1
            })
          ])
        ]),
        default: i(() => [
          r(o, {
            tableId: t.tableId,
            initOption: b(n),
            initSearchData: t.initSearchData,
            ref_key: "tableRef",
            ref: u
          }, null, 8, ["tableId", "initOption", "initSearchData"])
        ]),
        _: 1
      }, 8, ["modelValue", "title", "width", "custom-class"]);
    };
  }
};
export {
  E as default
};
