import { inject as p, computed as b, resolveComponent as v, openBlock as T, createBlock as F, mergeProps as h, unref as n, isRef as V, toHandlers as O } from "vue";
import o from "../../../utils/formUtil.js";
import { getPlaceholder as S } from "../../../utils/i18nUtil.js";
const k = {
  __name: "Date",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(d, { emit: f }) {
    p("formData");
    const s = p("changeFieldData"), a = d, y = f, m = b({
      get: () => {
        if (o.isTimestamp(a.modelValue)) {
          let e = u();
          return e = e.replace("YYYY", "yyyy"), e = e.replace("DD", "dd"), o.dateFormat(new Date(a.modelValue), e);
        } else
          return a.modelValue;
      },
      set: (e) => {
        y("update:modelValue", e);
      }
    });
    function c(e) {
      s && s(a.option.fieldName, e);
    }
    function u() {
      let e = "YYYY-MM-DD";
      return m.value == "99991231" && a.option.dateOption && a.option.dateOption.isLong === !0 ? e = "长期" : o.isEmpty(a.option.dateFormat.format) || (e = a.option.dateFormat.format.toUpperCase(), e = e.replace("HH:MM:SS", "HH:mm:ss")), e;
    }
    function D() {
      let e = null;
      return o.isEmpty(a.option.dateFormat.valueFormat) || (e = a.option.dateFormat.valueFormat.toUpperCase(), e = e.replace("HH:MM:SS", "HH:mm:ss")), e;
    }
    function g() {
      const e = a.option.dateOption;
      if (!e)
        return [];
      let t = [
        {
          text: "今天",
          value: /* @__PURE__ */ new Date()
        }
      ];
      return e.isLong === !0 && t.push({
        text: "长期",
        value: /* @__PURE__ */ new Date("9999/12/31")
      }), t;
    }
    function M(e) {
      const t = a.option.dateOption;
      let i = !0;
      if (!t)
        return i;
      if (t.bigDate || t.smallDate || t.defaultSmall || t.defaultBig) {
        let r = o.dateFormat(/* @__PURE__ */ new Date(), "yyyyMMdd");
        if (t.defaultSmall ? i = o.formatDate(r, "yyyyMMdd").getTime() > e.getTime() : t.smallDate && (i = o.formatDate(t.smallDate, "yyyyMMdd").getTime() > e.getTime()), t.defaultBig)
          if (t.smallDate || t.defaultSmall) {
            let l = o.formatDate(r, "yyyyMMdd");
            l && (i = i || e.getTime() > l.getTime());
          } else {
            let l = o.formatDate(r, "yyyyMMdd");
            l && (i = e.getTime() > l.getTime());
          }
        else if (t.bigDate && t.smallDate || t.defaultSmall) {
          let l = o.formatDate(t.bigDate, "yyyyMMdd");
          l && (i = i || e.getTime() > l.getTime());
        } else {
          let l = o.formatDate(t.bigDate, "yyyyMMdd");
          l && (i = e.getTime() > l.getTime());
        }
        return i;
      }
    }
    return (e, t) => {
      const i = v("el-date-picker");
      return T(), F(i, h({
        ref: "dateRef",
        modelValue: n(m),
        "onUpdate:modelValue": t[0] || (t[0] = (r) => V(m) ? m.value = r : null),
        format: u(),
        "value-format": D(),
        type: a.option.dateType,
        placeholder: n(S)(a.option),
        disabled: n(o).isEmpty(a.option.disabled) ? !1 : a.option.disabled,
        readonly: n(o).isEmpty(a.option.readOnly) ? !1 : a.option.readOnly,
        shortcuts: g(),
        "disabled-date": M
      }, O(d.event), { onChange: c }), null, 16, ["modelValue", "format", "value-format", "type", "placeholder", "disabled", "readonly", "shortcuts"]);
    };
  }
};
export {
  k as default
};
