import { ref as r, getCurrentInstance as se, computed as E, provide as f, watch as O, nextTick as H, resolveComponent as C, openBlock as N, createBlock as K, unref as S, normalizeClass as J, withCtx as g, createVNode as U, createElementBlock as ue, Fragment as me, renderList as fe, renderSlot as ce, createCommentVNode as de } from "vue";
import x from "../../../utils/formUtil.js";
import { initOption as pe, initFormData as z, initState as ve, initTableData as De, initEvent as L, initRule as M, changeState as ye } from "./form.js";
import { getFormValue as G } from "./interface/getFormValue.js";
import { setFormValue as Fe, setFormValueByFieldName as we } from "./interface/setFormValue.js";
import { validateForm as ge } from "./interface/validateForm.js";
import { clearValidate as xe } from "./interface/clearValidate.js";
import be from "../formItem/index.js";
const Pe = {
  __name: "Form",
  props: {
    formId: {
      type: String,
      required: !0
    },
    isDisabled: {
      type: Boolean,
      default: !1
    },
    initFormData: {
      type: Object,
      default: {}
    }
  },
  emits: ["onCreated"],
  setup(b, { expose: Q, emit: W }) {
    const D = r(null);
    r();
    const X = window.config.show_title, y = b;
    let c = se().proxy.$parent;
    const I = r(!1);
    let s = {};
    const m = r({});
    let k = {};
    const R = r("");
    let V = {}, F = [], T = {};
    const a = r(), $ = r(), _ = r(), w = r(), o = r({}), d = r({}), Y = r({}), Z = W;
    pe(y, (e) => {
      d.value = e, s = x.clone(e), a.value = s.formItem, m.value = s.init.pramDicItem, k = s.init.dicKeyData, R.value = s.init.formClass, V = ve(s), F = Object.keys(V), T = De(a), o.value = z(a.value, y.initFormData), _.value = L(a.value, c), w.value = M(a.value, c, o), p(), I.value = !0, H(() => {
        Z("onCreated");
      });
    });
    const A = E(() => {
      let e = [];
      for (let t = 0; t < s.columns; t++) {
        let l = t + "";
        e.push({ index: l });
      }
      return e;
    });
    function j(e, t) {
      F.indexOf(e) != -1 && p();
    }
    f("changeFieldData", j);
    function p() {
      let e = G(a.value, o.value);
      const t = ye(
        m.value,
        k,
        a.value,
        T,
        V,
        e,
        o
      );
      $.value = t, _.value = L(a.value, c), w.value = M(a.value, c, o);
    }
    O(
      () => y.initFormData,
      (e) => {
        I.value && (o.value = z(a.value, e), B.value = "", p());
      },
      {
        deep: !0
      }
    ), O(w, (e, t) => {
      if (t)
        for (let l in e)
          JSON.stringify(e[l]) != JSON.stringify(t[l]) && H(() => {
            q(l);
          });
    }), f(
      "formData",
      E(() => o.value)
    ), f("parentVm", c);
    const B = r("");
    f("currentEditFieldName", B), f("formItemOption", a);
    const ee = ({ row: e, column: t, rowIndex: l, columnIndex: n }) => {
      let v = e[n + ""];
      return v && [v.rowspan, v.colspan];
    }, te = (e) => {
      let t = e.row;
      for (let l in t)
        if (t[l].fieldType != "empty")
          return null;
      return { display: "none" };
    }, le = (e) => {
      let t = e.row;
      for (let l in t)
        if (t[l].fieldType == "label")
          return "label";
      return "";
    };
    function ae(e) {
      if (e.row[e.columnIndex] && e.row[e.columnIndex].fieldType == "empty" && e.row[e.columnIndex + 1] && e.row[e.columnIndex + 1].fieldType == "empty")
        return "is-empty";
    }
    let P = {};
    const oe = (e) => {
      if (e) {
        const t = e.getFormItem();
        P[t.fieldName] = t.ref;
      }
    };
    function h(e) {
      const t = G(a.value, o.value, e);
      return e ? t[e] : t;
    }
    f("getFormValue", h);
    const re = (e, t) => {
      if (typeof e == "object") {
        Fe(a.value, o, e);
        let l = !1;
        for (let n in e)
          if (F.indexOf(n) != -1) {
            l = !0;
            break;
          }
        l && p();
      } else
        typeof e == "string" && typeof t < "u" && (we(
          a.value,
          o,
          e,
          t
        ), F.indexOf(e) != -1 && p());
    }, ne = (e, t) => {
      ge(D, (l, n) => {
        l ? x.isFunction(e) && e(h()) : x.isFunction(t) && t(n);
      });
    }, q = (e, t) => {
      xe(D, e, () => {
        x.isFunction(t) && t();
      });
    };
    return Q({
      getFormValue: h,
      setFormValue: re,
      validateForm: ne,
      clearValidate: q,
      resetFields: () => {
        D.value.resetFields();
      },
      getFormItem: (e) => P[e],
      getParmDic: (e) => e ? m.value[e] : m.value,
      setParmDic: (e, t) => {
        t && t.length > 0 && (m.value[e] = t);
      }
      // /** @description validate form */
      // validate,
      // /** @description validate form field */
      // validateField,
      // /** @description reset fields */
      // resetFields,
      // /** @description clear validation status */
      // clearValidate,
      // /** @description scroll to field */
      // scrollToField,
    }), (e, t) => {
      const l = C("el-table-column"), n = C("el-table"), v = C("el-form");
      return I.value ? (N(), K(v, {
        key: 0,
        title: S(X) == !1 ? "" : y.formId,
        "label-position": d.value.labelPosition,
        model: o.value,
        rules: w.value,
        ref_key: "formRef",
        ref: D,
        disabled: !!(d.value.formDisabled || b.isDisabled),
        "label-width": "160px",
        class: J(R.value),
        "validate-on-rule-change": !1,
        "scroll-to-error": ""
      }, {
        default: g(() => [
          U(n, {
            noScrollbar: !0,
            data: $.value,
            "show-header": !1,
            "span-method": ee,
            "row-style": te,
            "row-class-name": le,
            "cell-class-name": ae,
            ref_key: "tableRef",
            ref: Y,
            "empty-text": " ",
            class: J(d.value.formDisabled || b.isDisabled ? "is-disabled" : "")
          }, {
            default: g(() => [
              (N(!0), ue(me, null, fe(S(A), (i) => (N(), K(l, {
                key: i.index,
                prop: i.index
              }, {
                default: g((u) => [
                  U(S(be), {
                    option: u.row[i.index],
                    modelValue: o.value,
                    "onUpdate:modelValue": t[0] || (t[0] = (ie) => o.value = ie),
                    event: u.row[i.index] && _.value[u.row[i.index].fieldName],
                    pramDicItem: u.row[i.index] && m.value[u.row[i.index].fieldName],
                    query: d.value.query,
                    ref_for: !0,
                    ref: oe
                  }, {
                    default: g(() => [
                      ce(e.$slots, u.row[i.index] && u.row[i.index].fieldName, { formData: o.value })
                    ]),
                    _: 2
                  }, 1032, ["option", "modelValue", "event", "pramDicItem", "query"])
                ]),
                _: 2
              }, 1032, ["prop"]))), 128))
            ]),
            _: 3
          }, 8, ["data", "class"])
        ]),
        _: 3
      }, 8, ["title", "label-position", "model", "rules", "disabled", "class"])) : de("", !0);
    };
  }
};
export {
  Pe as default
};
