import { inject as y, computed as h, ref as s, resolveComponent as A, openBlock as k, createElementBlock as P, Fragment as R, createVNode as x, unref as a, isRef as v, createBlock as _, resolveDynamicComponent as E } from "vue";
import O from "../../../utils/formUtil.js";
import H from "../../sys/sysUserDialog/index.js";
import I from "../../sys/sysRoleDialog/index.js";
import L from "../../sys/sysBrDialog/index.js";
import { getPlaceholder as z } from "../../../utils/i18nUtil.js";
import { useRoute as G } from "vue-router";
const Z = {
  __name: "PLTdialog",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String | Number,
    realFieldName: {
      type: String,
      required: !0
    },
    showFieldName: {
      type: String,
      required: !0
    },
    type: String
  },
  emits: ["update:modelValue"],
  setup(S, { emit: w }) {
    const V = y("formData"), c = y("changeFieldData"), T = G(), t = S, B = h(() => {
      let e = null;
      return t.type == "user" ? e = H : t.type == "role" ? e = I : t.type == "br" && (e = L), e;
    }), U = w, u = h({
      get: () => t.modelValue,
      set: (e) => {
        U("update:modelValue", e);
      }
    }), m = h({
      get: () => V.value[t.option.fieldDesc],
      set: (e) => {
        V.value[t.option.fieldDesc] = e;
      }
    }), D = s({}), b = s({}), N = s({}), d = s("checkbox"), F = s(""), f = s(!1);
    function C() {
      let e = t.option.option, l = u.value;
      e.isInDialog = !0, e.isAutoHeight = !0, e.type == "checkbox" ? (l = l.split(","), d.value = "checkbox") : d.value = "radio", F.value = l;
      let i = e.params;
      if (i) {
        let o = i.split(";");
        for (let p in o) {
          let n = o[p].split("-"), r = n[0], g = n[1];
          g = O.parsFieldName(g, V.value, T), b.value[r] = g;
        }
      }
      D.value = e, N.value = e.title, f.value = !0;
    }
    const j = y("parentVm");
    function q(e) {
      if (d.value == "checkbox") {
        let p = "", n = "";
        for (let r = 0; r < e.length; r++)
          p += e[r][t.realFieldName], n += e[r][t.showFieldName], r < e.length - 1 && (p += ",", n += ",");
        m.value = n, u.value = p + "@@@" + n, c && c(t.option.fieldName, p);
      } else
        m.value = e[t.showFieldName], u.value = e[t.realFieldName] + "@@@" + e[t.showFieldName], c && c(t.option.fieldName, e[t.realFieldName]);
      const i = t.option.option.saveCallBack, o = O.parentVmExist(j, i);
      o && o[i](e);
    }
    return (e, l) => {
      const i = A("el-input");
      return k(), P(R, null, [
        x(i, {
          ref: "input",
          type: "text",
          modelValue: a(m),
          "onUpdate:modelValue": l[0] || (l[0] = (o) => v(m) ? m.value = o : null),
          onClick: C,
          placeholder: a(z)(t.option),
          readonly: !0
        }, null, 8, ["modelValue", "placeholder"]),
        x(i, {
          type: "hidden",
          modelValue: a(u),
          "onUpdate:modelValue": l[1] || (l[1] = (o) => v(u) ? u.value = o : null),
          readonly: !0
        }, null, 8, ["modelValue"]),
        (k(), _(E(a(B)), {
          modelValue: a(f),
          "onUpdate:modelValue": l[2] || (l[2] = (o) => v(f) ? f.value = o : null),
          initOption: a(D),
          initSearchData: a(b),
          title: a(N),
          selectType: a(d),
          selectValue: a(F),
          onSubmit: q
        }, null, 40, ["modelValue", "initOption", "initSearchData", "title", "selectType", "selectValue"]))
      ], 64);
    };
  }
};
export {
  Z as default
};
