import { inject as m, computed as c, ref as v, watch as O, resolveComponent as b, openBlock as d, createBlock as y, mergeProps as j, unref as l, isRef as F, toHandlers as S, withCtx as P, createElementBlock as R, Fragment as q, renderList as A } from "vue";
import "../../../axios/config.js";
import "../../../../../node_modules/file-saver/dist/FileSaver.min.js";
import "../../../../../node_modules/decimal.js/decimal.js";
import "../../../store/index.js";
import { getLibraryOptionData4Select as E } from "../../../utils/libraryUtil.js";
import { getPlaceholder as H } from "../../../utils/i18nUtil.js";
import { setOptionValue as U, getOptionValue as h } from "../formItem/formItemMethod.js";
const Z = {
  __name: "Select",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String,
    pramDicItem: {
      type: Array,
      default() {
        return [];
      }
    },
    isMultiple: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue"],
  setup(V, { expose: D, emit: C }) {
    const _ = m("formData"), f = m("changeFieldData"), e = V, u = c(() => e.option.dataType === "library"), k = C, i = c({
      get: () => e.isMultiple ? e.modelValue ? e.modelValue.split("|") : [] : e.modelValue,
      set: (t) => {
        k("update:modelValue", t);
      }
    });
    function I(t) {
      f && f(e.option.fieldName, t);
    }
    const o = v(), g = v(!1);
    u.value && s();
    const w = c(() => !!(e.option.disabled || e.option.readOnly));
    O(
      () => e.option,
      (t) => {
        e.option.customOptions ? o.value = a(e.option.customOptions) : t.optionType === "1" ? o.value = a(t.dicItem) : t.optionType === "2" && e.pramDicItem && (o.value = a(e.pramDicItem));
      },
      {
        deep: !0,
        immediate: !0
      }
    ), O(
      () => e.pramDicItem,
      (t) => {
        e.option.customOptions ? o.value = a(e.option.customOptions) : e.option.optionType === "2" && t && (o.value = a(t));
      },
      {
        deep: !0
      }
    );
    function a(t) {
      const n = /* @__PURE__ */ new Map();
      return t.filter((r) => !n.has(r.optCode) && n.set(r.optCode, 1));
    }
    function x(t) {
      u.value && t === !0 && s("");
    }
    function s(t) {
      if (e.option.customOptions)
        o.value = a(e.option.customOptions);
      else {
        let n = {};
        n[e.option.fieldName] = t, E(
          _.value,
          e.option,
          n,
          o,
          g
        );
      }
    }
    const B = m("formItemOption");
    function L(t) {
      U(
        i,
        o,
        B,
        e.option.fieldName,
        t
      );
    }
    function M(t) {
      return h(i, o);
    }
    function N(t) {
      return h(i, o).find((r) => r.optCode == t);
    }
    return D({
      setOptions: L,
      getOptions: M,
      getOption: N
    }), (t, n) => {
      const r = b("el-option"), T = b("el-select");
      return d(), y(T, j({
        autocomplete: "off",
        multiple: e.isMultiple,
        filterable: !0,
        remote: l(u),
        "reserve-keyword": l(u),
        "remote-method": s,
        loading: l(g),
        "loading-text": "加载中",
        ref: "selectRef",
        modelValue: l(i),
        "onUpdate:modelValue": n[0] || (n[0] = (p) => F(i) ? i.value = p : null),
        placeholder: l(H)(e.option)
      }, S(e.event), {
        onVisibleChange: x,
        clearable: !0,
        disabled: l(w),
        onChange: I
      }), {
        default: P(() => [
          (d(!0), R(q, null, A(l(o), (p) => (d(), y(r, {
            key: p.optCode,
            label: p.optName,
            value: p.optCode
          }, null, 8, ["label", "value"]))), 128))
        ]),
        _: 1
      }, 16, ["multiple", "remote", "reserve-keyword", "loading", "modelValue", "placeholder", "disabled"]);
    };
  }
};
export {
  Z as default
};
