import { inject as m, computed as F, resolveComponent as y, openBlock as h, createBlock as v, mergeProps as V, unref as o, isRef as b, toHandlers as k } from "vue";
import a from "../../../utils/formUtil.js";
import { getPlaceholder as E, getEndPlaceholder as O } from "../../../utils/i18nUtil.js";
const j = {
  __name: "TimeGroup",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(n, { emit: p }) {
    m("formData");
    const l = m("changeFieldData"), e = n, d = p, r = F({
      get: () => e.modelValue,
      set: (t) => {
        d("update:modelValue", t);
      }
    });
    function s(t) {
      l && l(e.option.fieldName, t);
    }
    function u() {
      let t = "HH:mm:ss";
      return a.isEmpty(e.option.dateFormat.format) || (t = e.option.dateFormat.format.toLowerCase()), t;
    }
    function c() {
      let t = "HH:mm:ss";
      return a.isEmpty(e.option.dateFormat.valueFormat) || (t = e.option.dateFormat.valueFormat.toLowerCase()), t;
    }
    return (t, i) => {
      const f = y("el-time-picker");
      return h(), v(f, V({
        ref: "timeGroupRef",
        modelValue: o(r),
        "onUpdate:modelValue": i[0] || (i[0] = (g) => b(r) ? r.value = g : null),
        "is-range": "",
        "range-separator": e.option.separator,
        "start-placeholder": o(E)(e.option),
        "end-placeholder": o(O)(e.option),
        format: u(),
        "value-format": c(),
        disabled: o(a).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
        readonly: o(a).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly,
        "picker-options": o(a).isEmpty(e.option.dateOption) ? {} : e.option.dateOption
      }, k(n.event), { onChange: s }), null, 16, ["modelValue", "range-separator", "start-placeholder", "end-placeholder", "format", "value-format", "disabled", "readonly", "picker-options"]);
    };
  }
};
export {
  j as default
};
