import { resolveComponent as r, resolveDirective as x, openBlock as i, createBlock as a, withModifiers as v, withCtx as d, createElementVNode as w, createVNode as V, toDisplayString as b, unref as f, resolveDynamicComponent as C, renderSlot as T, withDirectives as O, createElementBlock as j, createTextVNode as B } from "vue";
import { isEditRowOrCell as u, tableFormatter as $ } from "./table.js";
import S from "./components/Hyperlinks.vue.js";
import U from "../forms/switch/index.js";
import { getContentTryIn18n as q } from "../../utils/i18nUtil.js";
import N from "../../utils/formUtil.js";
import F from "../index.js";
const P = { class: "h-form-error" }, G = {
  __name: "TableItem",
  props: {
    col: {
      type: Object,
      default: {}
    },
    scope: {
      type: Object,
      default: {}
    },
    rules: {
      type: Object,
      default: {}
    },
    pramDicItem: {
      type: Object,
      default: {}
    },
    events: {
      type: Object,
      default: {}
    },
    parentVm: {
      type: Object,
      default: {}
    },
    query: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["setIsTableBtn"],
  setup(e, { emit: D }) {
    const s = e, E = D, I = (l, t) => {
      let o = t.events;
      for (let n in o)
        if (o[n].type === "click") {
          const m = N.parentVmExist(s.parentVm, o[n].callback);
          m && m[o[n].callback](l, t.fieldName);
        }
    };
    function k(l) {
      return F[l.fieldType];
    }
    function y(l, t, o) {
      const n = N.parentVmExist(s.parentVm, l);
      n && (E("setIsTableBtn", !0), n[l](t, o));
    }
    return (l, t) => {
      const o = r("Warning"), n = r("el-icon"), m = r("el-form-item"), g = x("imgIcon");
      return u(e.scope, e.col) ? (i(), a(m, {
        key: 0,
        prop: "tableData." + e.scope.$index + "." + e.col.fieldName,
        rules: e.rules[e.col.fieldName] || [],
        onClick: t[1] || (t[1] = v((c) => I(e.scope.row, e.col), ["stop"])),
        onDblclick: t[2] || (t[2] = v(() => {
        }, ["stop"]))
      }, {
        error: d((c) => [
          w("div", P, [
            V(n, null, {
              default: d(() => [
                V(o)
              ]),
              _: 1
            }),
            w("span", null, b(f(q)(c.error)), 1)
          ])
        ]),
        default: d(() => [
          (i(), a(C(k(e.col)), {
            modelValue: e.scope.row[e.col.fieldName],
            "onUpdate:modelValue": t[0] || (t[0] = (c) => e.scope.row[e.col.fieldName] = c),
            option: e.col,
            pramDicItem: e.pramDicItem[e.col.fieldName] || [],
            event: e.events[e.col.fieldName] || {},
            isEdit: u(e.scope, e.col)
          }, null, 8, ["modelValue", "option", "pramDicItem", "event", "isEdit"]))
        ]),
        _: 1
      }, 8, ["prop", "rules"])) : e.col.isHref === !0 ? (i(), a(f(S), {
        key: 1,
        scope: e.scope,
        col: e.col,
        pramDicItem: e.pramDicItem[e.col.fieldName],
        onExecuteEvent: y
      }, null, 8, ["scope", "col", "pramDicItem"])) : e.col.fieldType === "switch" ? (i(), a(f(U), {
        key: 2,
        modelValue: e.scope.row[e.col.fieldName],
        "onUpdate:modelValue": t[3] || (t[3] = (c) => e.scope.row[e.col.fieldName] = c),
        option: e.col,
        isEdit: !e.query && u(e.scope, e.col),
        onChange: t[4] || (t[4] = (c) => y(e.col.switchValue.changeEvent, e.scope.row, e.scope.$index))
      }, null, 8, ["modelValue", "option", "isEdit"])) : T(l.$slots, "default", { key: 3 }, () => [
        O((i(), j("span", null, [
          B(b($(e.scope.row[e.col.fieldName], e.col, e.pramDicItem[e.col.fieldName])), 1)
        ])), [
          [g, { col: e.col, row: e.scope.row }]
        ])
      ]);
    };
  }
};
export {
  G as default
};
