import { ref as y, inject as F, resolveComponent as m, openBlock as o, createElementBlock as u, createElementVNode as c, createBlock as v, withCtx as p, createVNode as n, createCommentVNode as d, toDisplayString as P, unref as l, isRef as k, withDirectives as U, Fragment as f, renderList as x, createTextVNode as V, vShow as G } from "vue";
import "../../../store/index.js";
import S from "../../forms/formItem/index.js";
import L from "../components/QueryModelCustomBtns.vue.js";
import W from "../components/QueryModelBtns.vue.js";
import z from "../components/QueryModelTabs.vue.js";
import A from "../components/QueryModelInput.vue.js";
import { getFormValue as H } from "../../forms/form/interface/getFormValue.js";
import "./CompostionQueryModel.vue2.js";
const J = { class: "query-model-tools-div compostionQueryModel" }, K = { class: "compostionQueryModelContext" }, X = { class: "compostionQueryModelDiv" }, Y = {
  key: 1,
  class: "title"
}, Z = { class: "query-model-btn-div" }, ee = { class: "expandSreachBtns" }, te = /* @__PURE__ */ c("span", null, "收起", -1), oe = /* @__PURE__ */ c("span", null, "展开", -1), fe = {
  __name: "CompostionQueryModel",
  props: {
    option: {
      type: Object,
      required: !0
    },
    pramDicItem: {
      type: Object,
      default() {
        return [];
      }
    },
    sessionPageData: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(h, { expose: T }) {
    const e = h, C = y(), Q = y();
    let r = y(!1);
    function N() {
      r.value ? r.value = !1 : r.value = !0;
    }
    const a = y({});
    g("init");
    function g(i) {
      a.value = {};
      for (let t of e.option.columns)
        if (t.isQuery || t.isOtherQuery) {
          let _ = null;
          i == "init" && (_ = e.sessionPageData[t.fieldName], _ && (r.value = !0)), a.value[t.fieldName] = _ || t.value;
        }
    }
    const M = F("searchTable");
    function w() {
      const i = H(e.option.columns, a.value);
      M(i);
    }
    function q() {
      g(), w();
    }
    function B() {
      if (e.option.hasOther)
        return !0;
      for (let i of e.option.columns)
        if (i.isQuery)
          return !0;
      return !1;
    }
    return T({
      getCurrTabQuery: () => {
        try {
          return C.value.getCurrTabQuery();
        } catch {
          return null;
        }
      },
      getDynamicQuery: () => {
        try {
          return Q.value.getDynamicQuery();
        } catch {
          return null;
        }
      }
    }), (i, t) => {
      const _ = m("arrow-left-bold"), D = m("el-icon"), O = m("el-form-item"), $ = m("el-form"), I = m("el-button"), R = m("el-collapse-transition"), j = m("arrow-up"), E = m("arrow-down");
      return o(), u("div", J, [
        c("div", K, [
          c("div", X, [
            c("div", null, [
              h.option.isShowGoBack !== !1 ? (o(), v(D, {
                key: 0,
                class: "goBack",
                onClick: t[0] || (t[0] = (s) => i.$router.back(-1))
              }, {
                default: p(() => [
                  n(_)
                ]),
                _: 1
              })) : d("", !0),
              e.option.isShowTitle !== !1 ? (o(), u("span", Y, P(e.option.tableName), 1)) : d("", !0),
              n(l(z), {
                option: e.option,
                ref_key: "queryModelTabsRef",
                ref: C
              }, null, 8, ["option"])
            ]),
            c("div", null, [
              n(l(A), {
                option: e.option,
                searchData: e.sessionPageData.dynamicQuery,
                onCloseCollapse: t[1] || (t[1] = (s) => k(r) ? r.value = !1 : r = !1),
                ref_key: "queryModelInputRef",
                ref: Q
              }, null, 8, ["option", "searchData"]),
              c("div", Z, [
                n(l(L), {
                  option: e.option
                }, null, 8, ["option"]),
                n(l(W), {
                  option: e.option,
                  pramDicItem: h.pramDicItem
                }, null, 8, ["option", "pramDicItem"])
              ])
            ])
          ]),
          n(R, { class: "expandSearchCollapse" }, {
            default: p(() => [
              U(c("div", null, [
                n($, {
                  "label-position": "right",
                  "label-width": "100px"
                }, {
                  default: p(() => [
                    (o(!0), u(f, null, x(e.option.columns, (s) => (o(), u(f, null, [
                      s.isQuery ? (o(), v(l(S), {
                        key: 0,
                        option: s,
                        modelValue: l(a),
                        "onUpdate:modelValue": t[2] || (t[2] = (b) => k(a) ? a.value = b : null),
                        pramDicItem: e.pramDicItem[s.fieldName],
                        event: []
                      }, null, 8, ["option", "modelValue", "pramDicItem"])) : d("", !0)
                    ], 64))), 256)),
                    e.option.hasOther ? (o(), v(O, {
                      key: 0,
                      class: "otherWidgets",
                      label: "其他"
                    }, {
                      default: p(() => [
                        (o(!0), u(f, null, x(e.option.columns, (s) => (o(), u(f, null, [
                          s.isOtherQuery ? (o(), v(l(S), {
                            key: 0,
                            option: s,
                            modelValue: l(a),
                            "onUpdate:modelValue": t[3] || (t[3] = (b) => k(a) ? a.value = b : null),
                            pramDicItem: e.pramDicItem[s.fieldName],
                            event: []
                          }, null, 8, ["option", "modelValue", "pramDicItem"])) : d("", !0)
                        ], 64))), 256))
                      ]),
                      _: 1
                    })) : d("", !0)
                  ]),
                  _: 1
                }),
                c("div", ee, [
                  n(I, {
                    type: "primary",
                    "native-type": "submit",
                    onClick: w
                  }, {
                    default: p(() => [
                      V("查询")
                    ]),
                    _: 1
                  }),
                  n(I, { onClick: q }, {
                    default: p(() => [
                      V("重置")
                    ]),
                    _: 1
                  })
                ])
              ], 512), [
                [G, l(r)]
              ])
            ]),
            _: 1
          })
        ]),
        B() ? (o(), u("div", {
          key: 0,
          class: "expandBtn",
          onClick: N
        }, [
          l(r) ? (o(), u(f, { key: 0 }, [
            te,
            n(D, null, {
              default: p(() => [
                n(j)
              ]),
              _: 1
            })
          ], 64)) : (o(), u(f, { key: 1 }, [
            oe,
            n(D, null, {
              default: p(() => [
                n(E)
              ]),
              _: 1
            })
          ], 64))
        ])) : d("", !0)
      ]);
    };
  }
};
export {
  fe as default
};
